## node-babel7 7.20.15%2Bds1%2B~cs214.269.168

=== debian/watch ===
version=4
opts=\
repack,\
repacksuffix=+ds1,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel7-$1/ \
 https://github.com/babel/babel/tags .*/archive/.*/v?([\d\.]+).tar.gz group

opts=\
component=babel-plugin-dynamic-import-node,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-dynamic-import-node-$1/ \
 https://github.com/airbnb/babel-plugin-dynamic-import-node/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts="searchmode=plain,component=babel-plugin-syntax-async-generators,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-async-generators-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-async-generators https://registry.npmjs.org/@babel/plugin-syntax-async-generators/-/plugin-syntax-async-generators-([\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,component=babel-plugin-syntax-class-properties,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-class-properties-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-class-properties https://registry.npmjs.org/@babel/plugin-syntax-class-properties/-/plugin-syntax-class-properties-([\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,component=babel-plugin-syntax-class-static-block,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-class-static-block-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-class-static-block https://registry.npmjs.org/@babel/plugin-syntax-class-static-block/-/plugin-syntax-class-static-block-([\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,component=babel-plugin-syntax-dynamic-import,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-dynamic-import-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-dynamic-import https://registry.npmjs.org/@babel/plugin-syntax-dynamic-import/-/plugin-syntax-dynamic-import-([\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,component=babel-plugin-syntax-export-namespace-from,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-export-namespace-from-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from https://registry.npmjs.org/@babel/plugin-syntax-export-namespace-from/-/plugin-syntax-export-namespace-from-([\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,component=babel-plugin-syntax-json-strings,ctype=nodejs,pgpmode=none,filenamemangle=s/^.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-babel-plugin-syntax-json-strings-$1/" \
 https://registry.npmjs.org/@babel/plugin-syntax-json-strings https://registry.npmjs.org/@babel/plugin-syntax-json-strings/-/plugin-syntax-json-strings-([\d\.]+)@ARCHIVE_EXT@ checksum

## node-babel7 7.20.15+ds1+~cs214.269.168

=== Makefile ===
FLOW_COMMIT = 92bbb5e9dacb8185aa73ea343954d0434b42c40b
TEST262_COMMIT = ad034f3230911c73c8e47059022eb16121792912
TYPESCRIPT_COMMIT = ce85d647ef88183c019588bcf398320ce29b625a

# Fix color output until TravisCI fixes https://github.com/travis-ci/travis-ci/issues/7967
export FORCE_COLOR = true

SOURCES = packages codemods eslint

COMMA := ,
EMPTY :=
SPACE := $(EMPTY) $(EMPTY)
COMMA_SEPARATED_SOURCES = $(subst $(SPACE),$(COMMA),$(SOURCES))

YARN := yarn
NODE := $(YARN) node
MAKEJS := node Makefile.js


.PHONY: build build-dist watch lint fix clean test-clean test-only test test-ci publish bootstrap use-esm use-cjs

build:
	$(MAKEJS) build

build-bundle:
	$(MAKEJS) build-bundle

build-no-bundle:
	$(MAKEJS) build-no-bundle

generate-tsconfig:
	$(MAKEJS) generate-tsconfig

generate-type-helpers:
	$(MAKEJS) generate-type-helpers

build-flow-typings:
	$(MAKEJS) build-flow-typings

# For TypeScript older than 3.7
build-typescript-legacy-typings:
	$(MAKEJS) build-typescript-legacy-typings

build-standalone:
	$(MAKEJS) build-standalone

build-standalone-ci: build-no-bundle-ci
	$(MAKEJS) build-standalone

prepublish-build-standalone:
	$(MAKEJS) prepublish-build-standalone

build-dist: build-plugin-transform-runtime-dist

build-plugin-transform-runtime-dist:
	$(MAKEJS) build-plugin-transform-runtime-dist

watch:
	$(MAKEJS) watch

code-quality: tscheck lint

tscheck:
	$(MAKEJS) tscheck

lint-ci: lint check-compat-data-ci

check-compat-data-ci: check-compat-data

lint:
	$(MAKEJS) lint

fix: fix-json fix-js

fix-js:
	$(MAKEJS) fix-js

fix-json:
	$(MAKEJS) fix-json

clean:
	$(MAKEJS) clean

test-cov:
	$(MAKEJS) test-cov

test: lint test-only

clone-license:
	$(MAKEJS) clone-license

prepublish-build:
	$(MAKEJS) prepublish-build

prepublish:
	$(MAKEJS) prepublish

bootstrap-only:
	$(MAKEJS) bootstrap-only

bootstrap:
	$(MAKEJS) bootstrap

use-cjs:
	$(MAKEJS) use-cjs

use-esm:
	$(MAKEJS) use-esm

clean-lib:
	$(MAKEJS) clean-lib

clean-runtime-helpers:
	$(MAKEJS) clean-runtime-helpers

clean-all:
	$(MAKEJS) clean-all


build-no-bundle-ci: bootstrap-only
	$(YARN) gulp build-dev
	$(MAKE) build-flow-typings
	$(MAKE) build-dist

# Does not work on Windows; use "$(YARN) jest" instead
test-only:
	BABEL_ENV=test ./scripts/test.sh
	$(MAKE) test-clean

check-compat-data:
	cd packages/babel-compat-data; CHECK_COMPAT_DATA=true $(YARN) run build-data

build-compat-data:
	cd packages/babel-compat-data; $(YARN) run build-data

update-env-corejs-fixture:
	rm -rf packages/babel-preset-env/node_modules/core-js-compat
	$(YARN)
	$(MAKE) build-bundle
	OVERWRITE=true $(YARN) jest packages/babel-preset-env

test-ci: build-standalone-ci
	BABEL_ENV=test $(YARN) jest --maxWorkers=100% --ci
	$(MAKE) test-clean

test-ci-coverage:
	BABEL_ENV=test $(MAKE) bootstrap
	BABEL_ENV=test BABEL_COVERAGE=true $(YARN) c8 jest --maxWorkers=100% --ci
	rm -rf coverage/tmp

bootstrap-flow:
	rm -rf build/flow
	mkdir -p build
	git clone --filter=blob:none --sparse --single-branch --shallow-since=2021-05-01 https://github.com/facebook/flow.git build/flow
	cd build/flow && git sparse-checkout set "src/parser/test/flow"
	cd build/flow && git checkout -q $(FLOW_COMMIT)

test-flow:
	$(NODE) scripts/parser-tests/flow

test-flow-update-allowlist:
	$(NODE) scripts/parser-tests/flow --update-allowlist

bootstrap-typescript:
	rm -rf ./build/typescript
	mkdir -p ./build
	git clone --filter=blob:none --sparse --single-branch --shallow-since=2022-04-01 https://github.com/microsoft/TypeScript.git ./build/typescript
	cd build/typescript && git sparse-checkout set "tests"
	cd build/typescript && git checkout -q $(TYPESCRIPT_COMMIT)

test-typescript:
	$(NODE) scripts/parser-tests/typescript

test-typescript-update-allowlist:
	$(NODE) scripts/parser-tests/typescript --update-allowlist

bootstrap-test262:
	rm -rf build/test262
	mkdir -p build
	git clone --filter=blob:none --sparse --single-branch --shallow-since=2021-05-01 https://github.com/tc39/test262.git build/test262
	cd build/test262 && git sparse-checkout set "test" "harness"
	cd build/test262 && git checkout -q $(TEST262_COMMIT)

test-test262:
	$(NODE) scripts/parser-tests/test262

test-test262-update-allowlist:
	$(NODE) scripts/parser-tests/test262 --update-allowlist


new-version-checklist:
       # @echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       # @echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       # @echo "!!!!!!                                                   !!!!!!"
       # @echo "!!!!!! Add any message here, and UNCOMMENT THESE LINES!  !!!!!!"
       # @echo "!!!!!!                                                   !!!!!!"
       # @echo "!!!!!!                                                   !!!!!!"
       # @echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       # @echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       # @exit 1

new-version:
	$(MAKE) new-version-checklist
	git pull --rebase
	$(YARN) release-tool version -f @babel/standalone

# NOTE: Run make new-version first
publish:
	@echo "Please confirm you have stopped make watch. (y)es, [N]o:"; \
	read CLEAR; \
	if [ "_$$CLEAR" != "_y" ]; then \
		exit 1; \
	fi
	$(MAKE) prepublish
	$(YARN) release-tool publish
	$(MAKE) clean

publish-test:
ifneq ("$(I_AM_USING_VERDACCIO)", "I_AM_SURE")
	echo "You probably don't know what you are doing"
	exit 1
endif
	$(YARN) release-tool version $(VERSION) --all --yes --tag-version-prefix="version-e2e-test-"
	$(MAKE) prepublish-build
	node ./scripts/set-module-type.js clean
	YARN_NPM_PUBLISH_REGISTRY=http://localhost:4873 $(YARN) release-tool publish --yes --tag-version-prefix="version-e2e-test-"
	$(MAKE) clean

=== debian/changelog ===
node-babel7 (7.20.15+ds1+~cs214.269.168-9) unstable; urgency=medium

  * Bug fix: "rebuild fails against node-typescript 5.0.4 from
    experimental", thanks to Ananthu C V (Closes: #1090009).

 -- Bastien Roucariès <rouca@debian.org>  Mon, 27 Oct 2025 22:05:20 +0100

node-babel7 (7.20.15+ds1+~cs214.269.168-8) unstable; urgency=medium

  * tsc-workaround: add another ts-ignore for require. Closes: #1095784.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 14 Feb 2025 11:44:21 +0100

node-babel7 (7.20.15+ds1+~cs214.269.168-7) unstable; urgency=medium

  * Team update
  * Update to newer lru-cache

 -- Bastien Roucariès <rouca@debian.org>  Tue, 06 Aug 2024 14:01:43 +0000

node-babel7 (7.20.15+ds1+~cs214.269.168-6) unstable; urgency=medium

  * patch: tsc-workaround update
    Fix for nodejs 18.13 to 18.19 update

 -- Jérémy Lal <kapouer@melix.org>  Tue, 12 Dec 2023 13:15:28 +0100

node-babel7 (7.20.15+ds1+~cs214.269.168-5) unstable; urgency=medium

  * Team upload
  * Only evaluate own String/Number/Math methods
    (Closes: #1053880, CVE-2023-45133)

 -- Yadd <yadd@debian.org>  Fri, 13 Oct 2023 17:53:38 +0400

node-babel7 (7.20.15+ds1+~cs214.269.168-4) unstable; urgency=medium

  * Team upload
  * Add missing Breaks+Replaces against all node-babel-* that were in
    Debian 10 (Closes: #1037234)

 -- Yadd <yadd@debian.org>  Fri, 09 Jun 2023 13:35:18 +0400

node-babel7 (7.20.15+ds1+~cs214.269.168-3) unstable; urgency=medium

  * Team upload
  * Add Breaks+Replaces against node-babel-code-frame << 7
    (Closes: #1036942)

 -- Yadd <yadd@debian.org>  Tue, 30 May 2023 12:24:08 +0400

node-babel7 (7.20.15+ds1+~cs214.269.168-2) unstable; urgency=medium

  * Update minimum version of node-regexpu-core to 5.2.1~.
    packages/babel-helper-create-regexp-features-plugin/package.json has
    "regexpu-core": "^5.2.1" and not adding it breaks partial upgrades.

 -- Pirate Praveen <praveen@debian.org>  Thu, 16 Mar 2023 17:52:46 +0530

node-babel7 (7.20.15+ds1+~cs214.269.168-1) unstable; urgency=medium

  * Team upload
  * Update lintian override info format in d/source/lintian-overrides
    on line 2-11, 13-24.
  * Update standards version to 4.6.2, no changes needed.
  * New upstream version 7.20.15+ds1+~cs214.269.168

 -- Yadd <yadd@debian.org>  Fri, 17 Feb 2023 12:05:54 +0400

=== debian/control ===
Source: node-babel7
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>
Section: javascript
Priority: optional
Build-Depends: debhelper-compat (= 13)
 , dh-sequence-nodejs (>= 0.15.5~)
 , eslint
 , git <pkg.node-babel7.yarnpkg>
 , gulp (>= 4)
 , help2man
 , node-ampproject-remapping
 , node-array-each
 , node-babel7
 , node-babel7 (>= 7.18~) <!pkg.node-babel7.yarnpkg>
 , node-babel-helper-define-polyfill-provider
 , node-babel-plugin-polyfill-corejs2
 , node-babel-plugin-polyfill-corejs3
 , node-babel-plugin-polyfill-regenerator
 , node-builtins
 , node-cheerio
 , node-clean-css
 , node-css-select
 , node-css-selector-tokenizer
 , node-debbundle-acorn
 , node-deepmerge
 , node-eslint-plugin-eslint-plugin
 , node-gulp-babel (>= 8.0~)
 , node-gulp-cli (>= 2.3.0~)
 , node-gulp-newer
 , node-gulp-plumber
 , node-gulp-rename
 , node-he
 , node-htmlparser2
 , node-invariant
 , node-is-windows
 , node-jest-worker
 , node-jsdom
 , node-leven (>= 3.1.0+~cs1.1.1)
 , node-lru-cache (>= 10.0.1-2~)
 , node-liftoff (>= 3.1.0-4~)
 , node-lodash (>= 4.17.19+dfsg1~)
 , node-lodash-packages
 , node-make-error
 , node-merge-stream
 , node-multimatch
 , node-output-file-sync
 , node-recast
 , node-rimraf
 , node-rollup-plugin-babel (>= 5.3.1)
 , node-rollup-plugin-commonjs (>= 13.0.0)
 , node-rollup-plugin-inject
 , node-rollup-plugin-json (>= 4.1.0)
 , node-rollup-plugin-node-resolve (>= 9.0.0)
 , node-rollup-plugin-polyfill-node
 , node-rollup-plugin-replace (>= 2.3.3)
 , node-rollup-plugin-terser
 , node-serialize-javascript
 , node-supports-color (>= 5.3~)
 , node-through
 , node-through2
 , node-typescript
 , node-types-fs-readdir-recursive
 , node-types-jest
 , node-types-v8flags
 , node-vinyl-fs (>= 2.4.4-2~)
 , rollup (>= 2.61.1-4~)
 , terser (>= 5)
 , webpack
 , npm <pkg.node-babel7.yarnpkg>
 , yarnpkg <pkg.node-babel7.yarnpkg>
 , dh-nodejs
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/js-team/node-babel
Vcs-Git: https://salsa.debian.org/js-team/node-babel.git
Testsuite: autopkgtest-pkg-nodejs
Homepage: https://babeljs.io/
Rules-Requires-Root: no

Package: node-babel7
Architecture: all
Depends: ${misc:Depends}
 , node-ampproject-remapping
 , node-babel-plugin-add-module-exports
 , node-babel7-runtime (= ${binary:Version})
 , node-babel-plugin-polyfill-corejs2
 , node-babel-plugin-polyfill-corejs3
 , node-babel-plugin-polyfill-regenerator
 , node-browserslist (>= 4.16~)
 , node-chalk (>= 4~)
 , node-clone-deep
 , node-commander (>= 4.1.1)
 , node-convert-source-map
 , node-core-js (>= 3.1.1~)
 , node-core-js-compat
 , node-core-js-pure
 , node-debug
 , node-esutils
 , node-find-cache-dir
 , node-fs-readdir-recursive (>= 1.1.0~)
 , node-glob
 , node-globals
 , node-js-tokens
 , node-jsesc
 , node-json5
 , node-lodash (>= 4.17.19+dfsg1~)
 , node-lodash-packages
 , node-lru-cache (>= 10.0.1-2~)
 , node-make-dir
 , node-quick-lru
 , node-regenerator-transform (>= 0.14~)
 , node-regexpu-core (>= 5.2.1~)
 , node-resolve
 , node-semver (>= 7.0~)
 , node-slash
 , node-source-map
 , node-source-map-support
 , node-to-fast-properties
 , node-v8flags
 , nodejs:any
Suggests: node-babel-plugin-polyfill-es-shims
 , node-babel7-debug
Breaks: node-babel-core (<< 6.26.0+repack-3~)
 , node-babel-cli (<< 7)
 , node-babel-code-frame (<< 7)
 , node-babel-generator (<< 7)
 , node-babel-helper-bindify-decorators (<< 7)
 , node-babel-helper-builder-binary-assignment-operator-visitor (<< 7)
 , node-babel-helper-builder-react-jsx (<< 7)
 , node-babel-helper-call-delegate (<< 7)
 , node-babel-helper-explode-assignable-expression (<< 7)
 , node-babel-helper-explode-class (<< 7)
 , node-babel-helper-function-name (<< 7)
 , node-babel-helper-hoist-variables (<< 7)
 , node-babel-helper-optimise-call-expression (<< 7)
 , node-babel-helper-remap-async-to-generator (<< 7)
 , node-babel-helper-replace-supers (<< 7)
 , node-babel-helpers (<< 7)
 , node-babel-plugin-external-helpers (<< 7)
 , node-babel-plugin-syntax-async-generators (<< 7)
 , node-babel-plugin-syntax-class-properties (<< 7)
 , node-babel-plugin-syntax-decorators (<< 7)
 , node-babel-plugin-syntax-do-expressions (<< 7)
 , node-babel-plugin-syntax-dynamic-import (<< 7)
 , node-babel-plugin-syntax-flow (<< 7)
 , node-babel-plugin-syntax-function-bind (<< 7)
 , node-babel-plugin-syntax-jsx (<< 7)
 , node-babel-plugin-syntax-object-rest-spread (<< 7)
 , node-babel-plugin-transform-async-to-generator (<< 7)
 , node-babel-plugin-transform-exponentiation-operator (<< 7)
 , node-babel-plugin-transform-flow-strip-types (<< 7)
 , node-babel-plugin-transform-jscript (<< 7)
 , node-babel-plugin-transform-proto-to-assign (<< 7)
 , node-babel-plugin-transform-react-display-name (<< 7)
 , node-babel-plugin-transform-react-jsx (<< 7)
 , node-babel-plugin-transform-react-jsx-self (<< 7)
 , node-babel-plugin-transform-react-jsx-source (<< 7)
 , node-babel-plugin-transform-regenerator (<< 7)
 , node-babel-plugin-transform-runtime (<< 7)
 , node-babel-plugin-transform-strict-mode (<< 7)
 , node-babel-preset-env (<< 7)
 , node-babel-preset-flow (<< 7)
 , node-babel-preset-react (<< 7)
 , node-babel-register (<< 7)
 , node-babel-template (<< 7)
 , node-babel-traverse (<< 7)
Replaces: node-babel-cli (<< 7)
 , node-babel-code-frame (<< 7)
 , node-babel-generator (<< 7)
 , node-babel-helper-bindify-decorators (<< 7)
 , node-babel-helper-builder-binary-assignment-operator-visitor (<< 7)
 , node-babel-helper-builder-react-jsx (<< 7)
 , node-babel-helper-call-delegate (<< 7)
 , node-babel-helper-explode-assignable-expression (<< 7)
 , node-babel-helper-explode-class (<< 7)
 , node-babel-helper-function-name (<< 7)
 , node-babel-helper-hoist-variables (<< 7)
 , node-babel-helper-optimise-call-expression (<< 7)
 , node-babel-helper-remap-async-to-generator (<< 7)
 , node-babel-helper-replace-supers (<< 7)
 , node-babel-helpers (<< 7)
 , node-babel-plugin-external-helpers (<< 7)
 , node-babel-plugin-syntax-async-generators (<< 7)
 , node-babel-plugin-syntax-class-properties (<< 7)
 , node-babel-plugin-syntax-decorators (<< 7)
 , node-babel-plugin-syntax-do-expressions (<< 7)
 , node-babel-plugin-syntax-dynamic-import (<< 7)
 , node-babel-plugin-syntax-flow (<< 7)
 , node-babel-plugin-syntax-function-bind (<< 7)
 , node-babel-plugin-syntax-jsx (<< 7)
 , node-babel-plugin-syntax-object-rest-spread (<< 7)
 , node-babel-plugin-transform-async-to-generator (<< 7)
 , node-babel-plugin-transform-exponentiation-operator (<< 7)
 , node-babel-plugin-transform-flow-strip-types (<< 7)
 , node-babel-plugin-transform-jscript (<< 7)
 , node-babel-plugin-transform-proto-to-assign (<< 7)
 , node-babel-plugin-transform-react-display-name (<< 7)
 , node-babel-plugin-transform-react-jsx (<< 7)
 , node-babel-plugin-transform-react-jsx-self (<< 7)
 , node-babel-plugin-transform-react-jsx-source (<< 7)
 , node-babel-plugin-transform-regenerator (<< 7)
 , node-babel-plugin-transform-runtime (<< 7)
 , node-babel-plugin-transform-strict-mode (<< 7)
 , node-babel-preset-env (<< 7)
 , node-babel-preset-flow (<< 7)
 , node-babel-preset-react (<< 7)
 , node-babel-register (<< 7)
 , node-babel-template (<< 7)
 , node-babel-traverse (<< 7)
Provides: ${nodeBabel7:Provides}
 , babeljs (= ${binary:Version})
X-Javascript-Built-Using: ${nodejs:BuiltUsing}
Description: Babel compiler for writing next generation JavaScript
 Babel is a JavaScript compiler to use next generation JavaScript, today.
 .
 ES2015 and beyond: Babel has support for the latest version of JavaScript
 through syntax transformers. These plugins allow you to use new syntax, right
 now without waiting for browser support.

Package: node-babel7-runtime
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
 , node-regenerator-runtime
Provides: ${nodeBabel7Runtime:Provides}
X-Javascript-Built-Using: ${nodejs:BuiltUsing}
Description: Babel modular runtime helpers
 @babel/runtime is meant to be used as a runtime dependency along with the
 Babel plugin @babel/plugin-transform-runtime.

Package: node-babel7-standalone
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: ${nodeBabel7Standalone:Provides}
X-Javascript-Built-Using: ${nodejs:BuiltUsing}
Description: Standalone build of Babel for use in browsers and other non-Node.js environments
 @babel/standalone provides a standalone build of Babel for use in browsers
 and other non-Node.js environments.If you're using Babel in production, you
 should normally not use @babel/standalone. Instead, you should use a build
 system running on Node.js, such as Webpack, Rollup, or Parcel, to transpile
 your JS ahead of time.
 .
 However, there are some valid use cases for @babel/standalone:
  * It provides an easy, convenient way to prototype with Babel. Using
    @babel/standalone, you can get started using Babel with just a simple
    script tag in your HTML.
  * Sites that compile user-provided JavaScript in real-time, like JSFiddle,
    JS Bin, the REPL on the Babel site, JSitor, etc.
  * Apps that embed a JavaScript engine such as V8 directly, and want to use
    Babel for compilation
  * Apps that want to use JavaScript as a scripting language for extending the
    app itself, including all the goodies that ES2015 provides.
  * Other non-Node.js environments (ReactJS.NET, ruby-babel-transpiler,
    php-babel-transpiler, etc).

Package: node-babel7-debug
Architecture: all
Depends: ${misc:Depends}
Breaks: node-babel7 (<< 7.19.3+ds1+~cs214.250.186-2)
 , node-babel7-runtime (<< 7.19.3+ds1+~cs214.250.186-2)
 , node-babel7-standalone (<< 7.19.3+ds1+~cs214.250.186-2)
Multi-Arch: foreign
Description: Source-map files for node-babel7 packages
 Source map files for node-babel7, node-babel7-runtime and node-babel7-standalone

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

GULP=/usr/bin/gulp
BABELJSDESC="The compiler for writing next generation JavaScript"
BABELJSNODEDESC="CLI that works exactly the same as the Node.js CLI, with the added benefit of compiling with Babel presets and plugins before running it"
BABEL=/usr/bin/babeljs
OTHER_BABEL_COMPONENTS_TO_BUILD=babel-check-duplicated-nodes babel-plugin-dynamic-import-node babel-preset-modules babel-plugin-transform-replace-object-assign pirates
OTHER_BABEL_MODULES_TO_BUILD:=$(shell for m in $(OTHER_BABEL_COMPONENTS_TO_BUILD); do pkgjs-pjson $$m;done)

%:
	dh $@

override_dh_auto_configure:
ifeq (,$(filter pkg.node-babel7.yarnpkg,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	# Don't link internal modules
	pkgjs-install-minimal
	rm -rf node_modules/@jridgewell
	pkgjs-utils link_external_modules
	pkgjs-utils link_build_modules
else
	# No link when built with yarnpkg
endif

override_dh_auto_build:
ifeq (,$(filter pkg.node-babel7.yarnpkg,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	@echo
	@echo "Step 0: other builds"
	pkgjs-utils clean_internal_modules
	mv node_modules node_modules.save
	debian/rules other-babel-modules
	mv node_modules.save node_modules

	@echo
	@echo "Step 1: Link /usr/share/nodejs/@babel/* build dependencies into node_modules"
	LIST=`pkgjs-utils modules_list` && \
		for m in $$LIST `pkgjs-utils main`; do \
			if [ -e /usr/share/nodejs/$$m ]; then \
				rm -f node_modules/$$m; \
				ln -vs /usr/share/nodejs/$$m node_modules/$$m || true; \
			fi; \
		done
	ln -s ../../packages/babel-helper-string-parser node_modules/@babel/helper-string-parser || true
	@echo
	@echo "Step 2: build charcodes"
	cd charcodes; \
	for D in ./packages/*; do \
		mkdir "$$D/lib"; \
		$(BABEL) "$$D/src/index.js" -o "$$D/lib/index.js" --env-name "cjs"; \
		$(BABEL) "$$D/src/index.js" -o "$$D/lib/index.mjs" --env-name "esm"; \
	done

	@echo
	@echo "Step 3: build babel"

	#$(MAKE) prepublish-build  YARN=''
	#$(MAKE) prepublish-build-standalone YARN=''
	#gulp build-babel-standalone
	gulp generate-standalone
	#NODE_ENV=production BABEL_ENV=production STRIP_BABEL_8_FLAG=true $(MAKE) build-bundle
	node scripts/set-module-type.js
	NODE_ENV=production BABEL_ENV=production STRIP_BABEL_8_FLAG=true gulp build
	node packages/babel-types/scripts/generators/flow.js > packages/babel-types/lib/index.js.flow
	cd packages/babel-plugin-transform-runtime && node scripts/build-dist.js
	STRIP_BABEL_8_FLAG=true BABEL_ENV=production IS_PUBLISH=true gulp build-babel-standalone
	node scripts/generators/tsconfig.js
	node scripts/generators/archived-libs-typings.js

	@echo
	@echo "Step 4: build typescript declarations"

	# Workaround: babel wants tsc < 4.5
	perl -i -pe '$$_ = "// \@ts-ignore\n$$_"' \
		packages/babel-traverse/src/path/generated/asserts.d.ts \
		packages/babel-traverse/src/path/generated/validators.d.ts

	# Now use internal babel modules
	rm -rf dts
	LIST=`pkgjs-utils modules_list;pkgjs-utils main` && (cd node_modules && rm -rf $$LIST)
	pkgjs-utils link_internal_modules
	#for i in babel-*/ gensync packages/b*; do \
	#	NAME=`pkgjs-pjson $$i name`; \
	#	rm -rf node_modules/$$NAME; \
	#	cp -a $$i node_modules/$$NAME; \
	#done
	tsc -b .
	gulp bundle-dts
	node packages/babel-types/scripts/generators/typescript-legacy.js > packages/babel-types/lib/index-legacy.d.ts

	@echo
	@echo "Step 5: build @babel/standalone"

	#patch -p1 <debian/patches/ignore-rollup-warnings-for-standalone.patch
	gulp rollup-babel-standalone
	cd packages/babel-standalone && \
	terser -o babel.min.js babel.js
	#patch -R -p1 <debian/patches/ignore-rollup-warnings-for-standalone.patch
else
	rm -rf node_modules
	HOME=/build YARN_ENABLE_SCRIPTS=0 yarnpkg install
	HOME=/build yarnpkg add $(OTHER_BABEL_MODULES_TO_BUILD)
	#HOME=/build npm i --ignore-scripts
	#cd node_modules/@rollup/plugin-commonjs && patch -p1 <../../../.yarn/patches/@rollup__plugin-commonjs.patch
	pkgjs-utils link_internal_modules 2>/dev/null
	for m in `pkgjs-utils modules_list`; do \
		if test -e /usr/share/nodejs/$$m -a -L node_modules/$$m; then \
			rm -f node_modules/$$m; \
			ln -vs /usr/share/nodejs/$$m node_modules/$$m; \
		fi; \
	done
	HOME=/build $(MAKE) build
	NODE_PATH=../node_modules debian/rules other-babel-modules BABEL=../node_modules/.bin/babel
	cd charcodes && HOME=/build npm install --ignore-scripts && ./scripts/build.sh
endif
	help2man --no-info \
		--version-string $(DEB_VERSION_UPSTREAM) \
		-n $(BABELJSDESC) \
		packages/babel-cli/bin/babel.js > babeljs.1
	help2man --no-info \
		--version-string $(DEB_VERSION_UPSTREAM) \
		-n $(BABELJSNODEDESC) \
		packages/babel-node/bin/babel-node.js > babeljs-node.1

other-babel-modules:
	set -e; for m  in $(OTHER_BABEL_COMPONENTS_TO_BUILD); do \
			(echo "Building $$m"; \
				cd $$m; \
				rm -rf lib; \
				$(BABEL) --out-dir lib src --ignore '**/*.test.js'; \
			); \
			ls $$m/lib/*.js; \
		done

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
override_dh_auto_test:
endif

override_dh_install:
	dh_install
	find debian -name .npmignore -delete
	find debian -name .gitignore -delete
	find debian -name tsconfig.tsbuildinfo -delete
	cd debian/node-babel7 && rm -rf `cat ../../debian/node-babel7-*.install|sed 's/.* //g'`
	perl -i -pe 's#(?:\.\./)+usr/#/usr/#' `find debian/*/usr/share/nodejs -name '*.map'`
	# Move source-map files into node-babel7-debug
	dh_nodejs_build_debug_package node-babel7-debug

override_dh_installdocs:
	dh_installdocs
	# Auto-generate components docs
	dh_nodejs_autodocs auto_dispatch
	mv debian/node-babel7-debug/usr/share/doc/node-babel7-debug debian/node-babel7-debug/usr/share/
	rm -rf debian/node-babel7-debug/usr/share/doc/*
	mv debian/node-babel7-debug/usr/share/node-babel7-debug debian/node-babel7-debug/usr/share/doc/

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/node-babel7/usr/share/nodejs/@babel/cli/bin/babel-external-helpers.js \
		debian/node-babel7/usr/share/nodejs/@babel/cli/bin/babel.js \
		debian/node-babel7/usr/share/nodejs/@babel/node/bin/babel-node.js \
		debian/node-babel7/usr/share/nodejs/@babel/parser/bin/babel-parser.js

=== debian/tests/control ===
Depends: @, @builddeps@
Restrictions: allow-stderr
Features: test-name=rebuild-itself
Test-Command: ./debian/rules override_dh_auto_configure && ./debian/rules override_dh_auto_build
Architecture: amd64, arm64, armhf, i386, ppc64el, s390x
